/*
  This function create files (outputfile and errorlogfile) ?
  It opens a command prompt and execute a .bat file
*/
function ExecC816( commandline, outfile, errorfile )
   {
   /* this part should be done in the function calling this one */
   tempdir=objFSO.GetSpecialFolder(2);

   var tempbatfile= objFSO.CreateTextFile(tempdir+"\\runtool.bat",true);

   tempbatfile.Write("@echo off\n");

   tempbatfile.Write("rexrdr.exe"+" \""+outfile+"\" \""+errorfile+"\" "+commandline);
   tempbatfile.Write("\nIf Not errorlevel 1 goto END\n");
   tempbatfile.Write("echo Error: error code detected\n");
   tempbatfile.Write(":END");
   tempbatfile.Write("\n");

   var WshShell        = new ActiveXObject("WScript.Shell");

   var command="cmd.exe /c " +tempdir+"\\runtool.bat" ;

   WshShell.Run(command,0,true);
   tempbatfile.close();
   }

function GNUFilesLinkerManagerC816( ldlocfile )
   {
   fso = new ActiveXObject( "Scripting.FileSystemObject" );
   var WshShell        = new ActiveXObject("WScript.Shell");

   /* First we make the .ld file */
   var file             = objFSO.CreateTextFile( ldlocfile, true );
   var libdir           = Tools.GetPropertyValue( "", "Directories", "LibDir" );
   var monitorem        = Tools.GetPropertyValue( "LD", "LIB", "MonitorEM" );
   var monitor          = Tools.GetPropertyValue( "LD", "LIB", "Monitor" );
   var monitoruart      = Tools.GetPropertyValue( "LD", "LIB", "MonitorUART" );
   var irq              = Tools.GetPropertyValue( "LD", "LIB", "IRQ" );
   var wrappers         = Tools.GetPropertyValue( "LD", "LIB", "Wrappers" );
   var clib             = Tools.GetPropertyValue( "LD", "LIB", "CLib" );
   var mathlib          = Tools.GetPropertyValue( "LD", "LIB", "MathLib" );
   var libmodel         = Tools.GetPropertyValue( "LD", "LIB", "LibModel" );

   var processor        = Tools.GetPropertyValue( "Target", "ProcessorC816", "Processor" );
   var softcalls        = Tools.GetPropertyValue( "Target", "ProcessorC816", "SoftCalls" );
   var libsoftcalls     = Tools.GetPropertyValue( "Target", "ProcessorC816", "LibSoftCalls" );

   var defaultlibdir    = Tools.GetPropertyValue( "LD", "General", "DefaultLibDir" );
   var inputfiles       = Tools.GetPropertyValue( "LD", "General", "InputFiles" );
   var outputfile       = Tools.GetPropertyValue( "", "Build", "OutputFile" );
   var realfile         = Tools.GetPropertyValue( "LD", "Scripts", "File" );
   var defaultscript    = Tools.GetPropertyValue( "LD", "Scripts", "SCRIPTFILES" );
   var startupfile      = Tools.GetPropertyValue( "LD", "Startup", "File");
   var defaultstartup   = Tools.GetPropertyValue( "LD", "Startup", "DEFAULTSTARTUP" );
   var gendatainit      = Tools.GetPropertyValue( "LD", "Linker", "GenDatainit" );
   var defwrappers      = Tools.GetPropertyValue( "LD", "Linker", "DefWrappers" );
   var indirectcall     = Tools.GetPropertyValue( "LD", "Linker", "COMPRESSOR" );

   if( processor == "C816-TEST" )
   {
      processor = "C816";
   }

   var inctemplates     = defaultlibdir + processor; // A IMPLEMENTER DANS LES CONFIG

   // Init buffers and variables

   var WrapperFileName  = outputfile;
   var WrapperModuleName= outputfile;

   WrapperFileName   = WrapperFileName + ".wrapp.s";
   WrapperModuleName = WrapperModuleName + ".wrapp.o";

   // add startup file to the linker file il faudra regarder le cas d un startup specifier pour les /
   if( defaultstartup == "Yes" )
      {
      startupfile = inctemplates + "\\crt0.o";
      }

   if( startupfile != "" )
      {
     file.Write( "\nSTARTUP(\"" + startupfile + "\")" );
      }

   // copy an empty wrapper file for the prelink
   var emptywrapper = inctemplates + "\\..\\Common\\emptywrappers.o"

   fso.CopyFile( emptywrapper, WrapperModuleName );

   file.Write ("\nINPUT(\""+WrapperModuleName+"\")\n");

   // add the list of files to link
   var in_array = inputfiles.split(";");

   for(var i = 0; i<in_array.length; i++)
      {
      if( ("\""+startupfile+"\"") != in_array[i] )
         {
         file.Write ("INPUT(" + in_array[i] + ")\n");
         }
      }

   // add librairies

   if(monitorem=="1") // only available with EM6819 EM6869 targets
      {
      if (processor=="EM6819")
         {
         file.Write ("INPUT(\"" + inctemplates+"\\..\\EM6819\\Monitor.o" + "\")\n");
         }
		 
	  if ( processor == "EM6869" )
         {
            file.Write( "INPUT(\"" + inctemplates+"\\..\\EM6869\\Monitor.o" + "\")\n" );
         }	 
		 
      else
         {
         file.Write ("INPUT(\"" + inctemplates+"\\..\\Common\\Monitorhu.a" + "\")\n");
         file.Write ("INPUT(\"" + inctemplates+"\\..\\Common\\_monxe_calibratevalues.a" + "\")\n");
         }
      }
   else
      {
      // for the others the standard monitor library
      if( monitor == "1" )
         {
         
            // for the software uart monitor
            if( monitoruart == "1" )
               {
               file.Write ("INPUT(\"" + inctemplates+"\\..\\Common\\Monitor.a" + "\")\n");
               }
            else
               {
               file.Write ("INPUT(\"" + inctemplates+"\\..\\Common\\Monitorhu.a" + "\")\n");
               }

            file.Write ("INPUT(\"" + inctemplates+"\\..\\Common\\_monxe_calibratevalues.a" + "\")\n");
           
         }
      }

   // IRQ handler library
   if( irq == "1" )
      {
      file.Write ("INPUT(\"" + inctemplates+"\\IRQHandler.a" + "\")\n");
      }


   // copy an default wrapper file for the link
   if (defwrappers=="1")
      {
      var defwrapper=inctemplates+"\\..\\Common\\defwrappers.a";

      fso.CopyFile (defwrapper,WrapperModuleName);
      file.Write ("INPUT(\""+WrapperModuleName+"\")\n");
      }

   // add the outputfile
   file.Write ("OUTPUT(\"" + outputfile + "\")\n");

   // add scriptfile
   if (defaultscript== "Yes")
      {
      var scriptfile=inctemplates+"\\"+"crt0.ld";
      }
   else
      {
      var scriptfile= realfile;
      }

   file.Write ("INCLUDE \"" + scriptfile + "\"\n");

   //add search directory
   var lib_array = libdir.split(";");

   for(var i = 0; i<lib_array.length; i++)
      file.Write ("SEARCH_DIR(\"" + lib_array[i] + "\")\n");

   // handle softcalls for C routines and sof calls for low level ones
   if( softcalls == "Yes" )
      {
      var scalls= "_sc";
      }
   else
      {
      var scalls= "_hc";
      }

   if (libsoftcalls=="Yes")
      {
      var lscalls= "_lsc";
      }
   else
      {
      var lscalls= "_lhc";
      }

   // C library ( small or huge; softcall?; library softcalls?)
   if( clib == 1 )
      {
      file.Write("INPUT(\"libc_"+libmodel+"_rom"+scalls+lscalls+".a\")\n");
      }

   // C library ( small or huge; softcall?; library softcalls?)
   if( mathlib == 1 )
      {
      file.Write("INPUT(\"libm_"+libmodel+"_rom"+scalls+lscalls+".a\")\n");
      }

   // low level library with or without softcall
   if (libsoftcalls=="Yes")
      {
      file.Write("INPUT(\"libgcc_sc.a\")\n");
      }
   else
      {
      file.write("INPUT(\"libgcc_hc.a\")\n")
      }

   // Data initialisation
   if( gendatainit == "1" )
      {
      var emptydata   = inctemplates + "\\..\\Common\\Empty.axe.DataInit.o";
      var currentdata = outputfile + ".DataInit.o";

      fso.CopyFile( emptydata, currentdata );

      file.Write( "INPUT(\"" + currentdata + "\")\n" );
      }

   // Generate indirect calls for Code compressor
   if( indirectcall == "1" )
      {
      file.Write( "GEN_INDIRECT_LISTING(\"" + outputfile + ".indcalls\")\n" );
      }

   /* if wrappers must be generated */
   if( 1 /*wrappers == "1"*/)
      {
      /* we make the command lines that will be used for loop to generate wrappers */

      // the options that can not be written in the ld file
      var execute  = Tools.GetPropertyValue( "Target", "Tools", "Execute" );
      var mapfile  = Tools.GetPropertyValue( "LD", "Linker", "MAPFILE" );
      var cross    = Tools.GetPropertyValue( "LD", "Linker", "CROSS" );
      var warnonce = Tools.GetPropertyValue( "LD", "Linker", "WARNONCE" );
      var more     = Tools.GetPropertyValue( "LD", "Linker", "MORE" );

      // The test variables.
      var noerror    = false;
      var maxwrapper = 200;

      // The redirection files.
      var logfilename      = outputfile + ".wLog";
      var errorlogfilename = outputfile + ".eLog";
      var wrapperadded     = false;

      //make the same link command line that the one that will be directly executed in the LD tool.
      var mapfilechain = mapfile.split("!");

      mapfile = mapfilechain[1];

      var linkcommand = "\""+execute+"\" "+"-Wl,-T -Xlinker "+ "\""+ldlocfile+"\" "+"-u _start -nostartfiles "+"-Wl,-Map -Xlinker "+"\""+mapfile+"\" "+cross+" "+warnonce+" "+more ;
      //make the assembler command line.
      var assemblercommand = "\" c816-as.exe\" "+ "\""+WrapperFileName+"\" "+"-o "+ "\""+WrapperModuleName+"\" " ;

      /* Generate data initialisation */
      if( gendatainit == "1" )
         {
         var tempres       = outputfile + ".dbg.out";
         var tempreserr    = outputfile + ".dbg.err";
         var srecfilename  = outputfile + ".srec";
         var asmfilename   = outputfile + ".DataInit.s";
         var objfilename   = outputfile + ".DataInit.o";

         ExecC816(linkcommand, tempres, tempreserr);

         var dbgerr = objFSO.GetFile(tempreserr);
         var dbgout = objFSO.GetFile(tempres);

         if (dbgerr.Size < 1)
            {
            if (objFSO.FileExists(tempres))
               {
               objFSO.DeleteFile(tempres,true);
               }

            if (objFSO.FileExists(tempreserr))
               {
               objFSO.DeleteFile(tempreserr,true);
               }

            tempreserr+="_";
            tempres+="_";

            var sreccommand= "c816-objcopy.exe \""+outputfile+"\" --target=srec \""+srecfilename+"\"";

            ExecC816(sreccommand, tempres, tempreserr);

            var dbgerr = objFSO.GetFile(tempreserr);
            var dbgout = objFSO.GetFile(tempres);

            if( dbgerr.Size < 1 )
               {
               if ( objFSO.FileExists( tempres ) )
                  {
                  objFSO.DeleteFile( tempres, true );
                  }

               if (objFSO.FileExists( tempreserr ) )
                  {
                  objFSO.DeleteFile( tempreserr, true );
                  }

               tempreserr += "_";
               tempres    += "_";

               if ( indirectcall == "1" )  var asmcommand= "c816-srec2rom.exe \""+srecfilename+"\" -o \""+asmfilename+"\" -asm \""+"\" -indcalls \""+outputfile+".indcalls\"";
			   else                        var asmcommand= "c816-srec2rom.exe \""+srecfilename+"\" -o \""+asmfilename+"\" -asm \"";
			

               ExecC816( asmcommand, tempres, tempreserr );

               var dbgerr = objFSO.GetFile(tempreserr);
               var dbgout = objFSO.GetFile(tempres);

               if( dbgerr.Size < 1 )
                  {
                  if( objFSO.FileExists( tempres ) )
                     {
                     objFSO.DeleteFile( tempres, true );
                     }

                  if( objFSO.FileExists( tempreserr ) )
                     {
                     objFSO.DeleteFile( tempreserr, true );
                     }

                  tempreserr += "_";
                  tempres    += "_";

                  var objcommand = "c816-as.exe \""+asmfilename+"\" -o \""+objfilename+"\" "+"--gstabs\"";

                  ExecC816( objcommand, tempres, tempreserr );

                  var dbgerr = objFSO.GetFile(tempreserr);
                  var dbgout = objFSO.GetFile(tempres);

                  if( dbgerr.Size < 1 )
                     {
                     tempreserr+="_";
                     tempres+="_";

                     if( indirectcall == "1" ) file.Write("NOMORE_GEN_INDIRECT_LISTING\n");

                     if( objFSO.FileExists( tempres ) )
                        {
                        objFSO.DeleteFile( tempres, true );
                        }

                     if( objFSO.FileExists( tempreserr ) )
                        {
                        objFSO.DeleteFile( tempreserr, true );
                        }
                     }
                  else
                     {
					 WshShell.Popup("\nObject file generation failed in data initialisation\n\n");
                     if( objFSO.FileExists( tempres ) )
                        {
                        objFSO.DeleteFile( tempres, true );
                        }

                     if( objFSO.FileExists( tempreserr ) )
                        {
                        objFSO.DeleteFile( tempreserr, true );
                        }
                     }
                  }
               else
                  {
				  WshShell.Popup("\nAssembler file generation failed in data initialisation\n\n");
                  if( objFSO.FileExists( tempres ) )
                     {
                     objFSO.DeleteFile( tempres, true );
                     }

                  if( objFSO.FileExists( tempreserr ) )
                     {
                     objFSO.DeleteFile( tempreserr, true );
                     }
                  }
               }
            else
               {
			   WshShell.Popup("\nsrec file generation failed data initialisation\n\n");
               if( objFSO.FileExists( tempres ) )
                  {
                  objFSO.DeleteFile( tempres, true );
                  }

               if( objFSO.FileExists( tempreserr ) )
                  {
                  objFSO.DeleteFile( tempreserr, true );
                  }
               }
            }
         else
            {
			WshShell.Popup("\nprelink failed in data initialisation\n\n");
            if( objFSO.FileExists( tempres ) )
               {
               objFSO.DeleteFile( tempres, true );
               }

            if( objFSO.FileExists( tempreserr ) )
               {
               objFSO.DeleteFile( tempreserr, true );
               }
            }
         }
      }
   }

function GNUFilesLinkerManager( ldlocfile )
   {
   var file             = objFSO.CreateTextFile(ldlocfile, true);

   var libdir           = Tools.GetPropertyValue("", "Directories", "LibDir");
   var processor        = Tools.GetPropertyValue("Target","ProcessorARM", "Processor");
   var inputfiles       = Tools.GetPropertyValue("LD", "General", "InputFiles");
   var limit            = Tools.GetPropertyValue("LD", "Scripts", "StarterKitLimit");

   var outputfile       = Tools.GetPropertyValue("", "Build", "OutputFile");
   var defaultscript    = Tools.GetPropertyValue("LD", "Scripts", "SCRIPTFILES");
   var scriptfile       = Tools.GetPropertyValue("LD", "Scripts", "File");
   var bootmode         = Tools.GetPropertyValue("Target", "ProcessorARM", "BootMode");
   var uart0putc        = Tools.GetPropertyValue("LD", "LIB", "UART0PUTC");
   var stlib            = Tools.GetPropertyValue("LD", "LIB", "STLIB");
   var smallp           = Tools.GetPropertyValue("LD", "LIB", "SMALLP");
   var nofloatp         = Tools.GetPropertyValue("LD", "LIB", "NOFLOATP");
   var defaultlibdir    = Tools.GetPropertyValue("LD", "General", "DefaultLibDir");
   var CSX              = Tools.GetPropertyValue("Target","ProcessorARM","CSX");
   var hbaddr           = Tools.GetPropertyValue("Target","ProcessorARM","HighBankAddr");
   var thumb            = Tools.GetPropertyValue("Target", "ProcessorARM", "Thumb");

   var STRFamily        = processor.substr( 0, 5) + "x";

   var STR7             = 0;
   var STR9             = 0;
   var STM3             = 0;
   var LPC              = 0;
   var STRSubFamily     = "";
   var STMSubFamily     = "";

   var STM3_FlashSize   = 32;
   var STM3_RAMSize     = 6;
   var LPC_FlashAddr    = 0;
   var LPC_RAMAddr      = 0x10000000;
   var LPC_FlashSize    = 32;
   var LPC_RAMSize      = 6;
   var RAMOnly          =0;

   if(processor.substr( 0, 4) == "STR7")
      STR7 = 1;

   if(processor.substr( 0, 4) == "STR9")
      STR9 = 1;

   if(processor.substr( 0, 4) == "STM3")
      {
      STM3 = 1;
      STMSubFamily = processor.substr( 0, 8) + "x";
      }

   if(processor.substr( 0, 3) == "LPC")
      {
      LPC = 1;
      LPCFamily = processor.substr( 0, 5) + "x";
      }
   if(processor.substr( 0, 4) == "LPC3")
      {
      RAMOnly = 1;   
      }   

   //Write include INCLUDE
   var include;
   var DEFfile;

   if( defaultscript == "No" )
      {
      include = scriptfile;
      }
   else
      {
      include = defaultlibdir + "\\";
      //STR7
      if(STR7==1)
         {

         if(limit=="Yes")
            {
            STRSubFamily = STRFamily + "Fx" + "0";
            }
         else
            {
            STRSubFamily = STRFamily + "Fx" + processor.charAt(8);
            }

         include = defaultlibdir + "\\" + STRSubFamily;

         if(bootmode == "0")
            include = include + "_FLASH.ld";
         else if (bootmode == "1")
            include = include + "_RAM.ld";
         else
            include = include + "_EXT.ld";
         }

      //STR9
      else if(STR9==1)
         {
         STRSubFamily = STRFamily + "Fx" + processor.charAt(8) + processor.charAt(9);
         include = defaultlibdir + "\\" + STRSubFamily + "_";

         if(limit=="Yes")
            include = include + "32K_";

         if(bootmode == "0")
            include = include + "FLASH.ld";
         else if (bootmode == "1")
            include = include + "RAM.ld";
         else
            include = include + "EXT.ld";
         }

      //STM3
      else if(STM3==1)
         {
         var i = 0;
         //find RAM and FLASH sizes in Kbytes
         STM3_FlashSize = Tools.GetPropertyValue("Target","ProcessorARM","CodeSize") / 1024;
         STM3_RAMSize = Tools.GetPropertyValue("Target","ProcessorARM","RamSize") / 1024;
         var STM3_RAMStart = Tools.GetPropertyValue("Target","ProcessorARM","RAMStart"); //ǉ
         var STM3_FlashStart = Tools.GetPropertyValue("Target","ProcessorARM","CodeStart"); //ǉ

         //limit to 32K if selected
         if( limit == "Yes" )
            {
            if(STM3_FlashSize > 32)
               STM3_FlashSize = 32;

            if(STM3_RAMSize > 32)
               STM3_RAMSize = 32;
            }

         //find sub familly
         STRSubFamily = processor.substr( 0, 9) + "_" + STM3_FlashSize + "K_" + STM3_RAMSize + "K" ;

         //find templates directory
         include = defaultlibdir + "\\";

         //make default file name
         include = include + STRSubFamily;

         //make DEF file name
         DEFfile = include + "_DEF.ld";

         //make BOOT script according to BOOT option
         if(bootmode == "0")
            include = include + "_FLASH.ld";
         else if (bootmode == "1")  
            include = include + "_RAM.ld";
         else
            include = include + "_EXT.ld";

         //write STM32xxx_DEF.ld file, which includes memory sizes and stack pointer init val
         var file2 = objFSO.CreateTextFile(DEFfile, true);
         var endflash = 0x20000000 + ( STM3_RAMSize * 1024 ) ;
//" + LPC_RAMAddr.toString ( 16 ) + "
         file2.Write ("/*\n");
         file2.Write ("Linker subscript for STM32F103 definitions with " + STM3_FlashSize + "K Flash and " + STM3_RAMSize + "K RAM\n");
         file2.Write ("Copyright RAISONANCE 2007\n");
         file2.Write ("!!! This file is automatically generated by RIDE !!!\n");
         file2.Write ("Do not modify it, as it will be erased at every link.\n");
         file2.Write ("You can use, copy and distribute this file freely, but without any waranty.\n");
         file2.Write ("*/\n");
         file2.Write ("\n");
         file2.Write ("/* Memory Spaces Definitions */\n");
         file2.Write ("\n");
         file2.Write ("MEMORY\n");
         file2.Write ("{\n");
//         file2.Write ("  RAM (xrw) : ORIGIN = 0x20000000, LENGTH = " + STM3_RAMSize + "K\n");
//         file2.Write ("  FLASH (rx) : ORIGIN = 0x8000000, LENGTH = " + STM3_FlashSize + "K\n");
         file2.Write ("  RAM (xrw) : ORIGIN = " + STM3_RAMStart.toString(16) + ", LENGTH = " + STM3_RAMSize + "K\n"); //ύX
         file2.Write ("  FLASH (rx) : ORIGIN = " + STM3_FlashStart.toString(16) + ", LENGTH = " + STM3_FlashSize + "K\n"); //ύX
         file2.Write ("  FLASHB1 (rx) : ORIGIN = 0x00000000, LENGTH = 0\n");
         file2.Write ("  EXTMEMB0 (rx) : ORIGIN = 0x00000000, LENGTH = 0\n");
         file2.Write ("  EXTMEMB1 (rx) : ORIGIN = 0x00000000, LENGTH = 0\n");
         file2.Write ("  EXTMEMB2 (rx) : ORIGIN = 0x00000000, LENGTH = 0\n");
         file2.Write ("  EXTMEMB3 (rx) : ORIGIN = 0x00000000, LENGTH = 0\n");
         file2.Write ("}\n");
         file2.Write ("\n");
         file2.Write ("/* higher address of the user mode stack */\n");
         file2.Write ("_estack = 0x" + endflash.toString ( 16 ) + ";\n");
         file2.Write ("\n");
         file2.Close();
         }
      //LPC
      else if(LPC==1)
         {
         var i = 0;
         //find RAM and FLASH sizes in Kbytes
         LPC_FlashSize = Tools.GetPropertyValue("Target","ProcessorARM","CodeSize") / 1024;
         LPC_RAMSize = Tools.GetPropertyValue("Target","ProcessorARM","RamSize") / 1024;
         LPC_FlashAddr = Tools.GetPropertyValue("Target","ProcessorARM","CodeStart");
         LPC_RAMAddr = Tools.GetPropertyValue("Target","ProcessorARM","RamStart");

         //limit to 32K if selected
         if( limit == "Yes" )
            {
            if(LPC_FlashSize > 32)
               LPC_FlashSize = 32;

            if(LPC_RAMSize > 32)
               LPC_RAMSize = 32;
            }

         //find sub familly
         LPCSubFamily = processor.substr( 0, 5) + "_" + LPC_FlashSize + "K_" + LPC_RAMSize + "K" ;

         //find templates directory
         include = defaultlibdir + "\\";

         //make default file name
         include = include + LPCSubFamily;

         //make DEF file name
         DEFfile = include + "_DEF.ld";

         //make BOOT script according to BOOT option
         if(bootmode == "0")
            include = include + "_FLASH.ld";
         else if (bootmode == "1")
            include = include + "_RAM.ld";   
         else
            include = include + "_EXT.ld";

         //write LPCxxx_DEF.ld file, which includes memory sizes and stack pointer init val
         var file2 = objFSO.CreateTextFile(DEFfile, true);
         var endram = parseInt(LPC_RAMAddr) + ( LPC_RAMSize * 1024 ) ;

         file2.Write ("/*\n");
         file2.Write ("Linker subscript for LPC definitions with " + LPC_FlashSize + "K Flash and " + LPC_RAMSize + "K RAM\n");
         file2.Write ("Copyright RAISONANCE 2008\n");
         file2.Write ("!!! This file is automatically generated by RIDE !!!\n");
         file2.Write ("Do not modify it, as it will be erased at every link.\n");
         file2.Write ("You can use, copy and distribute this file freely, but without any waranty.\n");
         file2.Write ("*/\n");
         file2.Write ("\n");
         file2.Write ("/* Memory Spaces Definitions */\n");
         file2.Write ("\n");
         file2.Write ("MEMORY\n");
         file2.Write ("{\n");
         file2.Write ("  RAM (xrw) : ORIGIN = " + LPC_RAMAddr.toString ( 16 ) + ", LENGTH = " + LPC_RAMSize + "K\n");
         file2.Write ("  FLASH (rx) : ORIGIN = " + LPC_FlashAddr.toString ( 16 ) + ", LENGTH = " + LPC_FlashSize + "K\n");
         file2.Write ("  FLASHB1 (rx) : ORIGIN = 0x00000000, LENGTH = 0\n");
         file2.Write ("  EXTMEMB0 (rx) : ORIGIN = 0x00000000, LENGTH = 0\n");
         file2.Write ("  EXTMEMB1 (rx) : ORIGIN = 0x00000000, LENGTH = 0\n");
         file2.Write ("  EXTMEMB2 (rx) : ORIGIN = 0x00000000, LENGTH = 0\n");
         file2.Write ("  EXTMEMB3 (rx) : ORIGIN = 0x00000000, LENGTH = 0\n");
         file2.Write ("}\n");
         file2.Write ("\n");
         file2.Write ("/* higher address of the user mode stack */\n");
         file2.Write ("_estack = 0x" + endram.toString ( 16 ) + ";\n");
         file2.Write ("\n");
         file2.Close();
         }
      else
         {
         //error
         }
      }

   //Write a blank line
   file.WriteBlankLines(1) ;

   // Write lib dir
   file.Write ("SEARCH_DIR(\".\")\n");

   var lib_array = libdir.split(";");

   for(var i = 0; i<lib_array.length; i++)
      file.Write ("SEARCH_DIR(\"" + lib_array[i] + "\")\n");

   var startupfile = Tools.GetPropertyValue("LD","Startup", "File");

   //find default startup file if selected
   if( Tools.GetPropertyValue("LD","Startup", "DEFAULTSTARTUP") == "Yes" )
      startupfile = defaultlibdir + "\\crt0_" + STRFamily + ".o" ;

   //Write startup file in linker script
   if( startupfile.length > 0 )
      file.Write ("STARTUP(\"" + startupfile + "\")\n");

   //Write input files
   var in_array = inputfiles.split(";");

   for(var i = 0; i<in_array.length; i++)
      {
      if( startupfile != in_array[i] )
         file.Write ("INPUT(" + in_array[i] + ")\n");
      }

   // include UART0 Putchar lib
   if(uart0putc=="1")
      {
      file.Write("EXTERN( __io_putchar )\n");
      file.Write("EXTERN( _write )\n");

      if(thumb == "-mthumb")
         file.Write("INPUT(\""+STRFamily+"_io_putchar_thumb.a\")\n");
      else
         file.Write("INPUT(\""+STRFamily+"_io_putchar.a\")\n");
      }

   // include small printf lib
   if(smallp=="1")
      {
      if(nofloatp=="1")
         {
         if(thumb == "-mthumb")
            file.Write("INPUT(\"smallprintf_thumb.a\")\n");
         else
            file.Write("INPUT(\"smallprintf.a\")\n");
         }
      else
         {
         if(thumb == "-mthumb")
            file.Write("INPUT(\"e_stdio_thumb.a\")\n");
         else
            file.Write("INPUT(\"e_stdio.a\")\n");
         }
      }

   // include stlib
   if(stlib=="1")
      {
      if(STM3 != 0)
         {
         file.Write("INPUT(\"" + STMSubFamily + "_thumb.lib\")\n");
         }
      else
         {
         if(thumb == "-mthumb")
            file.Write("INPUT(\"" + STRFamily + "_thumb.lib\")\n");
         else
            file.Write("INPUT(\"" + STRFamily + ".lib\")\n");
         }
      }

   //Write output file
   file.Write ("OUTPUT(\"" + outputfile + "\")\n");

   //Include linker script
   file.Write ("INCLUDE \"" + include + "\"\n");

   file.Close();

   //
   // Create include ld file
   //
  if(defaultscript == "Yes")
    {
    file = objFSO.CreateTextFile(include, true);
    //STR7

    if(STR7==1)
      {
      file.Write ("/*\nDefault linker script for "+STRSubFamily+"\nCopyright RAISONANCE S.A.S. 2007\n*/\n\n");
      file.Write ("/* include the common STRxxx sub-script */\nINCLUDE \""+STRFamily+"_COMMON.ld\"\n\n");
      file.Write ("/* include the memory spaces definitions sub-script */\n");
      file.Write ("INCLUDE \"" + STRSubFamily + "_DEF.ld\"\n\n");
      }
    else if (STR9==1)
      {
      //default memory regions sizes
      var flashb0_size_str = "32K";
      var flashb1_size_str = "0";
      var bb_size  = 0; //the real size is 8K*(2^(bb_size+2)) (32K->0, 64K->1, ...)
      var nbb_size = 3; //the real size is roughly 8K*(2^(nbb_size)) (0->0, 16K->1, 32K->2, 64K->3, ...)
      var bb_size_str  = "0x00";
      var nbb_size_str = "0x03";
      var ram_size_str = "32K";

      //memory regions sizes...

      //RAM size is determined by the 9th and 8th characters of target name
      switch(processor.substr(9,1))
        {
        case '0':
          ram_size_str ="16K";
          break;
        default:
          {
          switch(processor.substr(8,1))
            {
            case '3':
              ram_size_str = "64K";
              break;
            case '4':
              ram_size_str = "96K";
              break;
            }
          break;
          }
        }

      //FLASH size is determined by the 9th character of target name
        {
        var bigbank_size   = 1; //the real size is 8K*(2^(bigbank_size)) (32K->2, 64K->3, ...)
        var smallbank_size = 0; //the real size is roughly 8K*(2^(smallbank_size)) (0->0, 16K->1, 32K->2, 64K->3, ...)
        switch(processor.substr(9,1))
          {
          case '2': //FLASH is 256+32 K
            bigbank_size=5;
            smallbank_size=2;
            break;
          case '4': //FLASH is 512+32 K
            bigbank_size=6;
            smallbank_size=2;
            break;
          case '6': //FLASH is 1024+128 K
            bigbank_size=7;
            smallbank_size=4;
            break;
          case '7': //FLASH is 2048+128 K
            bigbank_size=8;
            smallbank_size=4;
            break;
          }
        //reverse or not according to which bank is the boot bank
        if(CSX=="0")
          {
          // flashb0 is at 0, flashb1 at HBAddr
          bb_size = bigbank_size-2;
          nbb_size = smallbank_size;
          }
        else
          {
          // flashb1 is at 0, flashb0 at HBAddr
          bb_size = smallbank_size-2;
          nbb_size = bigbank_size;
          }
        }

      //real size of second bank, for alignment
      if(nbb_size)
        NonBootBankSize=16*1024*(1<<(nbb_size)); //(processor[9]=='4')?(512*1024):(256*1024);
      else
        NonBootBankSize=0;

      //get non-boot-bank address
      NonBootBankAddress = parseInt(hbaddr,16);
      if(NonBootBankAddress.isNaN)
      {
        NonBootBankAddress = Math.max(NonBootBankSize, 16*1024*(1<<(bb_size+2)));
      }
      // Reflect the adjustment into hbaddr
      hbaddr = "0x" + NonBootBankAddress.toString(16);

      if(limit=="Yes")
        {
        //limit RAM to 32K, except if we only have 16K of RAM
        if(processor.substr(10,1)!='0')
          ram_size_str = "32K";
        //minimum possible values for FLASH config
        bb_size=0;
        nbb_size=0;
        }

      //write str from values
      var flashb0_size = 8*(1<<(bb_size+2));
      flashb0_size_str = flashb0_size.toString() + "K";

      if(nbb_size)
        {
        var flashb1_size = 8*(1<<(nbb_size));
        flashb1_size_str = flashb1_size.toString() + "K";
        }
      else
        flashb1_size_str = "0";

      //trick needed for system memory
      if( nbb_size < 3 )
        nbb_size=3;

      bb_size_str  = "0x" + bb_size.toString(16);
      nbb_size_str = "0x" + nbb_size.toString(16);

      //read template file and write the customized contents to final script file
      file.Write ("/*\nDefault linker script for "+STRSubFamily);
      file.Write ("\nCopyright RAISONANCE S.A.S. 2007\n*/\n\n");
      file.Write ("/* include the common STRxxx sub-script */\nINCLUDE \""+STRFamily+"_COMMON.ld\"\n\n");

      file.Write ("\n/*********** BEGIN SUBSCRIPT ************/\n");

      filedefloc = defaultlibdir + "\\STR91xFxxx_DEF.ld";
      var templatefile = objFSO.OpenTextFile(filedefloc);
      var templatebuffer = templatefile.ReadAll();
      templatefile.Close();

      templatebuffer = templatebuffer.replace("<flashb0_size>",   flashb0_size_str);
      templatebuffer = templatebuffer.replace("<flashb1_size>",   flashb1_size_str);
      templatebuffer = templatebuffer.replace("<bb_size>",        bb_size_str);
      templatebuffer = templatebuffer.replace("<nbb_size>",       nbb_size_str);
      templatebuffer = templatebuffer.replace("<flashb1_origin>", hbaddr);
      templatebuffer = templatebuffer.replace("<nbb_addr>",       "0x"+(NonBootBankAddress/4).toString(16));
      templatebuffer = templatebuffer.replace("<ram_size>",       ram_size_str);

//      WshShell.Popup(processor+"\n==============================\n\n"+templatebuffer);

      file.Write(templatebuffer);
      file.Write ("/************ END SUBSCRIPT *************/\n\n");

      }
    else  if (STM3==1)//STM3
      {
      file.Write ("/*\nDefault linker script for "+STRSubFamily+"\nCopyright RAISONANCE S.A.S. 2007\n*/\n\n");
      file.Write ("/* include the common STMxxx sub-script */\n");
      file.Write ("INCLUDE \"" + STMSubFamily + "_COMMON.ld\"\n\n");
      file.Write ("/* include the memory spaces definitions sub-script */\n");
      file.Write ("INCLUDE \"" + STRSubFamily + "_DEF.ld\"\n\n");
      }
    else  if (LPC==1)//LPC
      {
      file.Write ("/*\nDefault linker script for "+STRSubFamily+"\nCopyright RAISONANCE S.A.S. 2007\n*/\n\n");
      file.Write ("/* include the memory spaces definitions sub-script */\n");
      file.Write ("INCLUDE \"" + LPCSubFamily + "_DEF.ld\"\n\n");
      file.Write ("/* include the common LPCxxx sub-script */\n");
      // file.Write ("INCLUDE \"" + LPCFamily + "_COMMON.ld\"\n\n");
      file.Write ("INCLUDE \"" + "LPCx_COMMON.ld\"\n\n");
      }

    file.Write ("/* include the sections management sub-script for FLASH mode */\n");
    file.Write ("INCLUDE \"sections_");

    switch(bootmode)
      {
      case "0" :
        file.Write("FLASH");
        break;
      case "1" :
        { 
        if(RAMOnly==1)
            file.Write("RAMonly");
        else     
            file.Write("RAM");
        break;
        }
      case "2" :
      default :
        file.Write("EXT");
        break;
      }

    file.Write (".ld\"\n");
    file.Close();
    }
  }

/*
 * GNUOutputManager (tempdeplocfile, sizedeplocfile, deplocfile )
 *
 * Make an xml file for dependencies and code size info from two tempory files
 *
 *
 * Args :
 *    tempdeplocfile : tempory file having dep info
 *    sizedeplocfile : tempory file having size info
 *    deplocfile     : output XML file
 *
 */

function  GNUOutputManager (tempdeplocfile, sizedeplocfile, deplocfile )
   {
   var objDOMOutput    = new ActiveXObject("MSXML2.DOMDocument");

   //open deptmp file

   // open and create dep file
   // read deptemp file and put sting separated by a blank into an array
   var arrayfilebuf;
   var linebuf;           // Buffer for reading lines

   objDOMOutput.appendChild(objDOMOutput.createNode(1,"DepXml",""));
   var root = objDOMOutput.documentElement.selectSingleNode("//DepXml/");

   root.appendChild(objDOMOutput.createNode(1,"Dependencies",""));
   var nodedepends = objDOMOutput.documentElement.selectSingleNode("//DepXml/Dependencies");

   if( objFSO.FileExists( tempdeplocfile ) )
      {
      var tempfilehandle = objFSO.OpenTextFile( tempdeplocfile );

      while( !tempfilehandle.AtEndOfStream )
         linebuf += tempfilehandle.ReadLine();

      tempfilehandle.Close();

      objFSO.DeleteFile(tempdeplocfile,true);

      if( (linebuf != "") && (linebuf))
         {
         //replace the space in directory files with a specla character before calling split
         linebuf      = linebuf.replace(/\\ /g, "!");
         linebuf      = linebuf.replace(/\ !/g, " ");

         arrayfilebuf = linebuf.split(" ");

         //loop in dependencies and create xml nodes

         for(i=0; i < arrayfilebuf.length ; i++)
            {
            if ((arrayfilebuf[i]!="") && (arrayfilebuf[i]!="undefined") )
               {
               var ext = objFSO.GetExtensionName(arrayfilebuf[i]);

               if (ext != "o:" && ext != "c" && ext != "s")
                  {
                  var node  = objDOMOutput.createNode(1,"Dep","");
                  var attr  = objDOMOutput.createAttribute("File");
                  var text;

                  // replace "!" by " "
                  text  = arrayfilebuf[i].replace(/!/g, " ");

                  //replaces "/" by "\"
                  //text = text.replace(/\x2f/g, "\\");

                  //removes "\.\"
                  //text  = text.replace(/\\.\\/g, "");

                  // remplace "\toto\..\" by "\"
                  //text  = text.replace(/[^\\]+\\..\\/g, "");

                  if(text.charAt(0) == '/')
                     {
                     //check if the first '/' is followed by "?drive/"

                     if((text.charAt(2)=='d') && (text.charAt(3)=='r') && (text.charAt(4)=='i') &&
                           (text.charAt(5)=='v') && (text.charAt(6)=='e') )
                        {
                        text = text.replace("/","");
                        text = text.replace("drive/",":/");
                        }

                     //check if the first '/' is followed by "?drive/"
                     else if((text.charAt(1)=='c') && (text.charAt(2)=='y') && (text.charAt(3)=='g') &&
                             (text.charAt(4)=='d') && (text.charAt(5)=='r')  && (text.charAt(6)=='i')
                             && (text.charAt(7)=='v')  && (text.charAt(8)=='e') )
                        {
                        text = text.replace("/cygdrive","");
                        text = text.replace("/c","c:");
                        }
                     }

                  attr.text  = text;
                  node.attributes.setNamedItem(attr);
                  nodedepends.appendChild(node);
                  }
               }
            }
         }
      }

   //
   // have size info
   //
   if( objFSO.FileExists( sizedeplocfile ) )
      {
      var matches;
      var sizefilehandle = objFSO.OpenTextFile( sizedeplocfile );
      var size_text = "0";
      var size_data = "0";
      var size_bss  = "0";

      sizefilehandle.ReadLine();
      linebuf=sizefilehandle.ReadLine();

      matches = linebuf.match(/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+)\s+.*$/);
      if(matches)
         {
         size_text = matches[1];
         size_data = matches[2];
         size_bss  = matches[3];
         }

      var node  = objDOMOutput.createNode(1,"InfosString","");
      var attr  = objDOMOutput.createAttribute("Value");
      attr.text  = "text=" + size_text + " data=" + size_data + " bss=" + size_bss;
      node.attributes.setNamedItem(attr);
      root.appendChild(node);

      //close and delete size file
      sizefilehandle.Close();
      objFSO.DeleteFile(sizedeplocfile);
      }

   objDOMOutput.save(deplocfile);
   }

function  GNUOutputManagerC816 (tempdeplocfile, sizedeplocfile, deplocfile )
   {
   var objDOMOutput    = new ActiveXObject("MSXML2.DOMDocument");
   var WshShell        = new ActiveXObject("WScript.Shell");
   //open deptmp file

   // open and create dep file
   // read deptemp file and put sting separated by a blank into an array
   var arrayfilebuf;
   var linebuf;           // Buffer for reading lines

   objDOMOutput.appendChild(objDOMOutput.createNode(1,"DepXml",""));
   var root = objDOMOutput.documentElement.selectSingleNode("//DepXml/");

   root.appendChild(objDOMOutput.createNode(1,"Dependencies",""));
   var nodedepends = objDOMOutput.documentElement.selectSingleNode("//DepXml/Dependencies");

   if( objFSO.FileExists( tempdeplocfile ) )
      {
      var tempfilehandle = objFSO.OpenTextFile( tempdeplocfile );

      while( !tempfilehandle.AtEndOfStream )
         linebuf += tempfilehandle.ReadLine();

      tempfilehandle.Close();

      objFSO.DeleteFile(tempdeplocfile,true);

      if( (linebuf != "") && (linebuf))
         {
         //replace the space in directory files with a specla character before calling split
         linebuf      = linebuf.replace(/\\ /g, "!");
         linebuf      = linebuf.replace(/\ !/g, " ");

         arrayfilebuf = linebuf.split(" ");

         //loop in dependencies and create xml nodes

         for(i=0; i < arrayfilebuf.length ; i++)
            {
            if ((arrayfilebuf[i]!="") && (arrayfilebuf[i]!="undefined") )
               {
               var ext = objFSO.GetExtensionName(arrayfilebuf[i]);

               if (ext != "o:" && ext != "c" && ext != "s")
                  {
                  var node  = objDOMOutput.createNode(1,"Dep","");
                  var attr  = objDOMOutput.createAttribute("File");
                  var text;

                  // replace "!" by " "
                  text  = arrayfilebuf[i].replace(/!/g, " ");

                  //replaces "/" by "\"
                  //text = text.replace(/\x2f/g, "\\");

                  //removes "\.\"
                  //text  = text.replace(/\\.\\/g, "");

                  // remplace "\toto\..\" by "\"
                  //text  = text.replace(/[^\\]+\\..\\/g, "");

                  if(text.charAt(0) == '/')
                     {
                     //check if the first '/' is followed by "?drive/"

                     if((text.charAt(2)=='d') && (text.charAt(3)=='r') && (text.charAt(4)=='i') &&
                           (text.charAt(5)=='v') && (text.charAt(6)=='e') )
                        {
                        text = text.replace("/","");
                        text = text.replace("drive/",":/");
                        }

                     //check if the first '/' is followed by "?drive/"
                     else if((text.charAt(1)=='c') && (text.charAt(2)=='y') && (text.charAt(3)=='g') &&
                             (text.charAt(4)=='d') && (text.charAt(5)=='r')  && (text.charAt(6)=='i')
                             && (text.charAt(7)=='v')  && (text.charAt(8)=='e') )
                        {
                        text = text.replace("/cygdrive","");
                        text = text.replace("/c","c:");
                        }
                     }

                  attr.text  = text;
                  node.attributes.setNamedItem(attr);
                  nodedepends.appendChild(node);
                  }
               }
            }
         }
      }

   //
   // have size info
   //
   if( objFSO.FileExists( sizedeplocfile ) )
      {
      var matches;
      var sizefilehandle = objFSO.OpenTextFile( sizedeplocfile );
      var size_text  = "0";
      var size_data  = "0";
      var size_bss   = "0";
	  var size_rodata= "0";
	  var all_data   = "0";

      sizefilehandle.ReadLine();
      while (linebuf=sizefilehandle.ReadLine())
	  {
       if (matches = linebuf.match(/\s*\.text\s*([0-9]+)\s+([0-9]+)/))
	   {
	    size_text+=matches[1];
	   }
	   
	   if (matches = linebuf.match(/\s*\.data\s*([0-9]+)\s+([0-9]+)/))
	   {
	    size_data+=matches[1];
	   }
	   
	   if (matches = linebuf.match(/\s*\.bss\s*([0-9]+)\s+([0-9]+)/))
	   {
	    size_bss+=matches[1];
	   }
	   
	   if (matches = linebuf.match(/\s*\.rodata\s*([0-9]+)\s+([0-9]+)/))
	   {
	    size_rodata+=matches[1]; 
	   }
	  
	  }
   
      size_text = size_text/4;
      all_data = parseFloat(size_data)+parseFloat(size_bss)+parseFloat(size_rodata);
      
      var node  = objDOMOutput.createNode(1,"InfosString","");
      var attr  = objDOMOutput.createAttribute("Value");
      attr.text  = "text=" + size_text + " data=" + all_data ;
      node.attributes.setNamedItem(attr);
      root.appendChild(node);

      //close and delete size file
      sizefilehandle.Close();
      objFSO.DeleteFile(sizedeplocfile);
      }

   objDOMOutput.save(deplocfile);
   }

/*
 * GNULDOutputManager ( sizedeplocfile, deplocfile )
 *
 * Make an xml file for code size info from tempory file for .elf file
 *
 *
 * Args :
 *    sizedeplocfile : tempory file having size info
 *    deplocfile     : output XML file
 *
 */

function  GNULDOutputManager (sizedeplocfile, deplocfile )
   {
   var objDOMOutput    = new ActiveXObject("MSXML2.DOMDocument");

   // open and create dep file
   // read deptemp file and put sting separated by a blank into an array
   var arrayfilebuf;
   var linebuf;           // Buffer for reading lines

   objDOMOutput.appendChild(objDOMOutput.createNode(1,"DepXml",""));
   var root = objDOMOutput.documentElement.selectSingleNode("//DepXml/");

   root.appendChild(objDOMOutput.createNode(1,"Dependencies",""));
   var nodedepends = objDOMOutput.documentElement.selectSingleNode("//DepXml/Dependencies");

   //
   // have size info
   //

   if( objFSO.FileExists( sizedeplocfile ) )
      {
      var sizefilehandle = objFSO.OpenTextFile( sizedeplocfile );
      var size_text = "0";
      var size_data = "0";
      var size_bss  = "0";
      var matches;

      sizefilehandle.ReadLine();
      linebuf=sizefilehandle.ReadLine();

      matches = linebuf.match(/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+)\s+.*$/);
      if(matches)
         {
         size_text = matches[1];
         size_data = matches[2];
         size_bss  = matches[3];
         }

      var node  = objDOMOutput.createNode(1,"InfosString","");
      var attr  = objDOMOutput.createAttribute("Value");
      attr.text  = "text=" + size_text + " data=" + size_data + " bss=" + size_bss;
      node.attributes.setNamedItem(attr);
      root.appendChild(node);

      //close and delete size file
      sizefilehandle.Close();
      objFSO.DeleteFile(sizedeplocfile);
      }

   objDOMOutput.save(deplocfile);
   //objDOMOutput.save("C:\\TEMP\\out.depxml");
   }

function  GNULDOutputManagerC816 (sizedeplocfile, deplocfile )
   {
   var objDOMOutput    = new ActiveXObject("MSXML2.DOMDocument");
   var WshShell        = new ActiveXObject("WScript.Shell");
   // open and create dep file
   // read deptemp file and put sting separated by a blank into an array
   var arrayfilebuf;
   var linebuf;           // Buffer for reading lines

   objDOMOutput.appendChild(objDOMOutput.createNode(1,"DepXml",""));
   var root = objDOMOutput.documentElement.selectSingleNode("//DepXml/");

   root.appendChild(objDOMOutput.createNode(1,"Dependencies",""));
   var nodedepends = objDOMOutput.documentElement.selectSingleNode("//DepXml/Dependencies");

   //
   // have size info
   //

   if( objFSO.FileExists( sizedeplocfile ) )
      {
      var matches;
      var sizefilehandle = objFSO.OpenTextFile( sizedeplocfile );
      var size_text  = "0";
      var size_data  = "0";
      
      linebuf=sizefilehandle.ReadLine();
      while (linebuf=sizefilehandle.ReadLine())
	   {
        if (!(matches = linebuf.match(/\s*\.stab(.)*\s*([0-9]+)\s+([0-9]+)/)) && !(matches = linebuf.match(/\s*\.debug(.)*\s*([0-9]+)\s+([0-9]+)/)))
	     {
	      if (matches = linebuf.match(/\s*\.([a-z0-9]+_*[a-z0-9]+)\s*([0-9]+)\s+([0-9]+)/))
	       {
			var binaddr = parseFloat(matches[3]);
			var limitaddr = parseFloat("1048576");
			var test = binaddr & limitaddr;
			if (test) size_text=parseFloat(matches[2])+parseFloat(size_text);
			else size_data=parseFloat(matches[2])+parseFloat(size_data);
	       }
	     }
	   }
      
      size_text = size_text/4;
      var node  = objDOMOutput.createNode(1,"InfosString","");
      var attr  = objDOMOutput.createAttribute("Value");
      attr.text  = "text=" + size_text + " data=" + size_data ;
      node.attributes.setNamedItem(attr);
      root.appendChild(node);

      //close and delete size file
      sizefilehandle.Close();
      objFSO.DeleteFile(sizedeplocfile);
      }

   objDOMOutput.save(deplocfile);
   //objDOMOutput.save("C:\\TEMP\\out.depxml");
   }

/* This function loads the debug tool to use for ARM and Cortex devices */
function Update_Debug_Tool(toolname)
   {
   var processor  = Project.GetPropertyValue("Target", "ProcessorARM", "Processor");

   if (processor == "")
      return;

   var type = processor.substr(0,4);

   if(type == "STR")
      {
      if( (processor.substr(0,5)=="STR73") && (toolname != "DebugTool_STR73x") && (toolname != "DebugTool_ARM") )
         return;
      else
         {
         if(toolname != "DebugTool_ARM")
            return;
         }
      }

   if ((type == "STM3") && (toolname != "DebugTool_CORTEX"))
      return;

   Project.HideProperty("RLINK_ARM","","", 1);
   Project.HideProperty("RLINK_CORTEX","","", 1);

   var isLib = (Project.GetPropertyValue("ApplicationLib", "General", "TargetFamily") != "");
   if (isLib)
      Project.HideProperty("Target","DebugARM", "", 1);
   else
      {
      var tool = Project.GetPropertyValue("Target", "DebugARM", toolname);

      var cfgfile = "ARM\\"+tool+".config";
      Project.UpdateCurNodeConfig("",cfgfile);

      var dbi = Project.GetSelectedDBI();
      Project.WriteIniValue("Application","DebugTool",tool, dbi);
      Project.WriteIniValue("Debug","ToolName",tool, dbi);
      }
   }

/* This function loads the debug tool to use for C816 devices */
function Update_Debug_ToolC816( toolname )
   {
   var processor = Project.GetPropertyValue( "Target", "ProcessorC816", "Processor" );

   if( processor == "" )
      {
      return;
      }

   var isLib = ( Project.GetPropertyValue( "ApplicationLib", "General", "TargetFamily" ) != "" );

   if( isLib )
      {
      Project.HideProperty( "Target", "DebugC816", "", 1 );
      }
   else
      {
      var tool    = Project.GetPropertyValue( "Target", "DebugC816", toolname );
      var cfgfile = "C816\\" + tool + ".config";

      Project.UpdateCurNodeConfig( "", cfgfile );

      var dbi        = Project.GetSelectedDBI();

      Project.WriteIniValue( "Application", "DebugTool", tool, dbi );
      Project.WriteIniValue( "Debug", "ToolName", tool, dbi );
      }
   }
